<?php
use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for RPhoneButtonTemplate StructType
 * @subpackage Structs
 */
class RPhoneButtonTemplate extends AbstractStructBase
{
    /**
     * The name
     * Meta informations extracted from the WSDL
     * - documentation: The template's name
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $name;
    /**
     * The isUserModifiable
     * Meta informations extracted from the WSDL
     * - documentation: Read-only
     * - maxOccurs: 1
     * - minOccurs: 0
     * - pattern: (t)|(f)|(true)|(false)|(0)|(1)
     * @var string
     */
    public $isUserModifiable;
    /**
     * The buttons
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var Buttons
     */
    public $buttons;
    /**
     * The uuid
     * Meta informations extracted from the WSDL
     * - pattern: \{........-....-....-....-............\}
     * @var string
     */
    public $uuid;
    /**
     * Constructor method for RPhoneButtonTemplate
     * @uses RPhoneButtonTemplate::setName()
     * @uses RPhoneButtonTemplate::setIsUserModifiable()
     * @uses RPhoneButtonTemplate::setButtons()
     * @uses RPhoneButtonTemplate::setUuid()
     * @param string $name
     * @param string $isUserModifiable
     * @param Buttons $buttons
     * @param string $uuid
     */
    public function __construct($name = null, $isUserModifiable = null, Buttons $buttons = null, $uuid = null)
    {
        $this
            ->setName($name)
            ->setIsUserModifiable($isUserModifiable)
            ->setButtons($buttons)
            ->setUuid($uuid);
    }
    /**
     * Get name value
     * @return string|null
     */
    public function getName()
    {
        return $this->name;
    }
    /**
     * Set name value
     * @param string $name
     * @return RPhoneButtonTemplate
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($name)), __LINE__);
        }
        $this->name = $name;
        return $this;
    }
    /**
     * Get isUserModifiable value
     * @return string|null
     */
    public function getIsUserModifiable()
    {
        return $this->isUserModifiable;
    }
    /**
     * Set isUserModifiable value
     * @param string $isUserModifiable
     * @return RPhoneButtonTemplate
     */
    public function setIsUserModifiable($isUserModifiable = null)
    {
        // validation for constraint: pattern
        if (is_scalar($isUserModifiable) && !preg_match('/(t)|(f)|(true)|(false)|(0)|(1)/', $isUserModifiable)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a scalar value that matches "(t)|(f)|(true)|(false)|(0)|(1)", "%s" given', var_export($isUserModifiable, true)), __LINE__);
        }
        // validation for constraint: string
        if (!is_null($isUserModifiable) && !is_string($isUserModifiable)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($isUserModifiable)), __LINE__);
        }
        $this->isUserModifiable = $isUserModifiable;
        return $this;
    }
    /**
     * Get buttons value
     * @return Buttons|null
     */
    public function getButtons()
    {
        return $this->buttons;
    }
    /**
     * Set buttons value
     * @param Buttons $buttons
     * @return RPhoneButtonTemplate
     */
    public function setButtons(Buttons $buttons = null)
    {
        $this->buttons = $buttons;
        return $this;
    }
    /**
     * Get uuid value
     * @return string|null
     */
    public function getUuid()
    {
        return $this->uuid;
    }
    /**
     * Set uuid value
     * @param string $uuid
     * @return RPhoneButtonTemplate
     */
    public function setUuid($uuid = null)
    {
        // validation for constraint: pattern
        if (is_scalar($uuid) && !preg_match('/\{........-....-....-....-............\}/', $uuid)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a scalar value that matches "\{........-....-....-....-............\}", "%s" given', var_export($uuid, true)), __LINE__);
        }
        // validation for constraint: string
        if (!is_null($uuid) && !is_string($uuid)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($uuid)), __LINE__);
        }
        $this->uuid = $uuid;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return RPhoneButtonTemplate
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
